<template>
    <div class="login">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                'pt-16',
            ]"
        >
            <v-col md="4" offset-md="4">
                <v-row>
                    <v-col class="pt-0 text-left">
                        <v-row>
                            <v-col class="pt-0">
                                <h2>
                                    {{ $t('common.signIn') }}
                                </h2>
                                <h3>
                                    or
                                    <v-btn
                                        text
                                        color="badge"
                                        class="lowercase pl-0"
                                        @click="goToPage(menus.SIGNUP.id)"
                                        >{{ $t('common.signUpFor') }}</v-btn
                                    >
                                </h3>
                            </v-col></v-row
                        >
                        <v-form
                            v-show="pageLoaded"
                            ref="loginForm"
                            lazy-validation
                            @submit.prevent
                        >
                            <v-row>
                                <v-col>
                                    <v-col
                                        cols="12"
                                        class="
                                            form-field
                                            font-metropolis-regular
                                            pl-0
                                        "
                                    >
                                        <!-- EMAIL -->
                                        <v-text-field
                                            ref="email"
                                            v-model="form.email.value"
                                            :label="$t('form.email.text')"
                                            :placeholder="
                                                $t('form.email.placeholder')
                                            "
                                            solo
                                            :rules="[
                                                requiredRules,
                                                requiredEmail,
                                            ]"
                                            :error-messages="form.email.error"
                                        ></v-text-field>

                                        <!-- PASSWORD -->
                                        <v-text-field
                                            ref="password"
                                            v-model="form.password.value"
                                            :append-icon="
                                                showPass
                                                    ? 'mdi-eye'
                                                    : 'mdi-eye-off'
                                            "
                                            :rules="[
                                                requiredRules,
                                                requiredMin,
                                            ]"
                                            :type="
                                                showPass ? 'text' : 'password'
                                            "
                                            name="input-10-2"
                                            :label="$t('form.password.text')"
                                            :placeholder="
                                                $t('form.password.placeholder')
                                            "
                                            :hint="$t('form.password.min')"
                                            class="input-group--focused"
                                            solo
                                            @keyup.enter="validateForm"
                                            @click:append="showPass = !showPass"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" class="pa-0">
                                        <v-btn
                                            :block="
                                                $vuetify.breakpoint.smAndDown
                                            "
                                            class="
                                                mt-5
                                                lowercase
                                                br-0
                                                pl-10
                                                pr-10
                                                font-syne-bold
                                            "
                                            color="badge"
                                            :loading="loading"
                                            :disabled="isButtonDisabled"
                                            @click="validateForm"
                                            >{{ $t('common.signIn') }}</v-btn
                                        >
                                    </v-col>
                                    <v-col cols="12" class="pa-0">
                                        <v-btn
                                            text
                                            color="badge"
                                            class="lowercase pl-0"
                                            @click="goToPage(menus.RECOVER.id)"
                                            >{{ $t('common.forgetPassword') }}
                                        </v-btn>
                                    </v-col>
                                </v-col>
                            </v-row>
                        </v-form>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component<any>({
    middleware: ['authenticated'],
    head() {
        return {
            title: this.$t('common.signIn'),
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenu',
        subscribedPlanId: 'subscription/getPlanId',
    }),
})
export default class Login extends Vue {
    // Data
    $refs!: { loginForm: HTMLFormElement }
    ref: any = {}
    pageLoaded: boolean = false
    menus!: any
    subscribedPlanId!: number
    loading: Boolean = false
    isButtonDisabled: Boolean = false
    showPass: Boolean = false
    formHasErrors: Boolean = false
    form: { [key: string]: any } = {
        email: {
            value: '',
            error: null,
            requestKey: 'email',
        },
        password: {
            value: '',
            error: null,
            requestKey: 'password',
        },
    }

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    requiredEmail(v: string) {
        if (v) {
            if (v.length > 0) {
                const pattern =
                    /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
                return (
                    pattern.test(v) || this.$t('form.validation.invalidEmail')
                )
            }
        }
        return this.$t('form.validation.required')
    }

    requiredMin(v: string) {
        if (v) {
            if (v.length >= 8) {
                return true
            }
        }
        return this.$t('form.password.min')
    }

    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.loginForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        this.isButtonDisabled = true
        this.loading = true

        this.$api.auth
            .login(this.form.email.value, this.form.password.value)
            .then((response) => {
                // Set Token and user
                this.$cookies.set('t', response.data.token)
                this.$axios.setToken(response.data.token, 'Bearer')
                this.$store.commit('user/setUser', response.data)

                // Get user subscription
                this.getUserSubscription()

                // Get user wishlist
                this.getWishlist()

                // Get user addresses
                this.getAddresses()

                // Get card setup
                this.getCardSetup()

                // Remove cart session if exists
                this.$cookies.remove('gc')
            })
            .catch((error) => {
                if (error.response.status === 401) {
                    const val = {
                        text: this.$t('snackbar.invalidEmailOrPassword'),
                        color: 'red',
                        icon: 'mdi-close-circle',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)

                    // Reopen button
                    this.isButtonDisabled = false
                    this.loading = false
                }
            })
    }

    getUserSubscription() {
        this.$api.user.subscriptions().then((response) => {
            if (Object.keys(response.data).length > 0) {
                this.$store.dispatch('subscription/setPlan', response.data)

                // Get user cart
                this.getCart()

                // Get shop cart
                this.getShopCart()
            } else {
                // Display snackbar
                const val = {
                    text: this.$t('snackbar.loginSuccess'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                // Redirect
                this.$router.push('/')
                this.loading = false
                this.isButtonDisabled = false
            }
        })
    }

    async getWishlist() {
        const userWishlist = await this.$api.wishlist.getWishlist()

        if (userWishlist) {
            this.$store.dispatch('wishlist/updateWishlist', userWishlist.data)
        }
    }

    async getAddresses() {
        const userAddresses = await this.$api.user.listAddress()

        if (userAddresses) {
            this.$store.dispatch('user/handleAddressApi', userAddresses.data)
        }
    }

    getCart() {
        this.$api.cart.getCart().then((response) => {
            if (Object.keys(response.data).length > 0) {
                this.$store.dispatch('cart/updateCart', response.data)

                // Get cart surcharges
                this.getCartSurcharges()
            } else {
                // Display snackbar
                const val = {
                    text: this.$t('snackbar.loginSuccess'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                // Redirect
                this.$router.push('/')
                this.loading = false
                this.isButtonDisabled = false
            }
        })
    }

    getShopCart() {
        // get shop cart
        this.$api.cart.getShopCart().then((response) => {
            if (response.data.items.length > 0) {
                this.$store.dispatch('cart/updateCartShop', response.data)
            } else {
                // Redirect
                this.$router.push('/')
                this.loading = false
                this.isButtonDisabled = false
            }
        })
    }

    getCartSurcharges() {
        this.$api.cart.getSurcharges().then((response) => {
            if (Object.keys(response.data).length > 0) {
                this.$store.dispatch('cart/updateSurcharges', response.data)
            }

            // Display snackbar
            const val = {
                text: this.$t('snackbar.loginSuccess'),
                color: 'green',
                icon: 'mdi-check',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)

            // Redirect
            this.$router.push('/')
            this.loading = false
            this.isButtonDisabled = false
        })
    }

    async getCardSetup() {
        const userCardSetup = await this.$api.user.cardSetup()
        if (userCardSetup) {
            this.$store.commit('cart/setStripeClientSecret', userCardSetup.data)
        }
    }

    // Methods
    goToPage(id: Number) {
        switch (id) {
            case this.menus.SIGNUP.id:
                this.$router.push(this.menus.SIGNUP.path)
                break

            case this.menus.RECOVER.id:
                this.$router.push(this.menus.RECOVER.path)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }
}
</script>
